package com.ibm.commerce.telesales.ATPT;
/*
  *-----------------------------------------------------------------
  * Licensed Materials - Property of IBM
  *
  * WebSphere Commerce
  *
  * (C) Copyright IBM Corp. 2009 All Rights Reserved.
  *
  * US Government Users Restricted Rights - Use, duplication or
  * disclosure restricted by GSA ADP Schedule Contract with
  * IBM Corp.
  *-----------------------------------------------------------------
  */
 */
//*---------------------------------------------------------------------
//* The sample contained herein is provided to you "AS IS".
//*
//* It is furnished by IBM as a simple example and has not been  
//* thoroughly tested
//* under all conditions.  IBM, therefore, cannot guarantee its 
//* reliability, serviceability or functionality.  
//*
//* This sample may include the names of individuals, companies, brands 
//* and products in order to illustrate concepts as completely as 
//* possible.  All of these names
//* are fictitious and any similarity to the names and addresses used by 
//* actual persons 
//* or business enterprises is entirely coincidental.
//*---------------------------------------------------------------------



import javax.servlet.ServletException;

import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Status;



import com.ibm.commerce.telesales.ATPT.tracing.ATPTTracingPlugin;
import com.ibm.commerce.telesales.exceptions.TelesalesServicesException;



import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;

import java.io.IOException;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.Date;


/**
 * This servlet will handle all the request and call Dummy request handler to handle the specific request.
 */
public class ProcessServlet  extends HttpServlet {
    /** IBM copyright notice field */
    private static final String COPYRIGHT = com.ibm.commerce.telesales.copyright.IBMCopyright.SHORT_COPYRIGHT;

	RequestHandler handler = null;
	
	public ProcessServlet() {
		super();
	}
	
	protected void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException,IOException
	{
		System.out.println("Entry : post method");
	
		//		 Initialise request handler 
			handler = new RequestHandler();

			response.setContentType("application/x-www-form-urlencoded");
			String requestType = request.getParameter("RequestType");
			Object responseBOD = null;
			if(requestType.equalsIgnoreCase("logon"))
			{
				responseBOD = processLogonrequest(request,response);
			}
			else if (requestType.equalsIgnoreCase("other"))
			{
				responseBOD = processRequest(request,response);				
			}
			else if(requestType.equalsIgnoreCase("logoff"))
			{
				responseBOD = new Boolean(processLogoffrequest(request,response));
			}
			else
			{
						// this means some problem occured and set errorcode as 400 to the status
						response.sendError(HttpServletResponse.SC_BAD_REQUEST);   //$NON-NLS-1$;
			}
			
			
			if (responseBOD == null) 
			{
				// this means some problem occured and set errorcode as 400 to the status
				response.sendError(HttpServletResponse.SC_BAD_REQUEST);   //$NON-NLS-1$;
			}
			else
			{
                //this means successfully done and set code as 200
				response.setStatus(HttpServletResponse.SC_OK);        //$NON-NLS-1$;
                PrintWriter toClient = response.getWriter();
                String body = "ResponseContent=" + responseBOD;
    		    toClient.write(body);
		        toClient.flush();
		        toClient.close();
			}
		
				
	}

	/**
	 * Identify which type of request it is and call respective method.
	 * There could be three types of request. 
	 * 1. Lolon request (Start service type)
	 * 2. Logoff request (Stop service type)
	 * 3. Other request (Other service type)
	 */
	protected void doGet(HttpServletRequest request, HttpServletResponse response)
	throws ServletException, IOException {
		
		// Initialise request handler 
		handler = new RequestHandler();
		
		String serivceRequestType = request.getParameter("hiddenInputField");  //$NON-NLS-1$;
		
		Object responseBOD = null;
		if(serivceRequestType.equalsIgnoreCase("logonJsp"))    //$NON-NLS-1$;
		{
			// process logon request
			responseBOD = processLogonrequest(request,response);
			
			if (responseBOD == null) 
			{
				// this means some problem occured and set errorcode as 400 to the status
				request.setAttribute("StatusCode",new Integer(HttpServletResponse.SC_BAD_REQUEST));   //$NON-NLS-1$;
				gotoPage(request, response, "LogonRequest");   //$NON-NLS-1$;
			}
			else
			{
                //this means successfully done and set code as 200
				request.setAttribute("StatusCode",new Integer(HttpServletResponse.SC_OK));        //$NON-NLS-1$;
				gotoPage(request,response,"logonResults");                                        //$NON-NLS-1$;
			}
		}
		else if(serivceRequestType.equalsIgnoreCase("requestJsp"))                                //$NON-NLS-1$;
		{
			//process other request
			responseBOD = processRequest(request,response);
			
			if (responseBOD == null) 
			{
				// this means some problem occured and set errorcode as 400 to the status				
				request.setAttribute("StatusCode",new Integer(HttpServletResponse.SC_BAD_REQUEST));
				gotoPage(request, response, "request");
			}
			else
			{
			    //this means successfully done and set code as 200
				request.setAttribute("StatusCode",new Integer(HttpServletResponse.SC_OK));
				gotoPage(request,response,"results");
			}
		}
		else if(serivceRequestType.equalsIgnoreCase("logoffJsp"))
		{
			// process logoff request. If successfully done, set status code as 200 else 400. 
			if(processLogoffrequest(request,response))
			{
				request.setAttribute("StatusCode",new Integer(HttpServletResponse.SC_OK));
				gotoPage(request,response,"logoffResults");
			}
			else
			{
				request.setAttribute("StatusCode",new Integer(HttpServletResponse.SC_BAD_REQUEST));
				gotoPage(request,response,"LogoffRequest");
			}
			
		}
		else 
		{
			// if request type field is mising, set the error code and log the error.
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("ATPTool.UniqueIdentifier"), IStatus.ERROR, ATPTTracingPlugin.getResourceString("ATPTool.errormessage.requestType"), null));
			request.setAttribute("ErrorMessage",ATPTTracingPlugin.getResourceString("ATPTool.errormessage.requestType"));
			request.setAttribute("StatusCode",new Integer(HttpServletResponse.SC_BAD_REQUEST));
		}
				
	}

	
	/**
	 * This method is used to process logon request. 
	 * This constructs service context for service type "Start" and call communication layer to
	 * logon.
	 * @param request
	 * @param response
	 * @return responseBod if successfully done, else returns null.
	 * @throws ServletException
	 * @throws IOException
	 */
	private Object  processLogonrequest(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {

		//Get the request parameter
		String id = request.getParameter("logonId");
		String pwd = request.getParameter("password");
		String langId = request.getParameter("langId");
		String localFilePath = request.getParameter("logonRequestFilePath");
		String directoryPath = request.getParameter("respDirPath");
		String resFileName = request.getParameter("resFileName");
		String requestFileContent = request.getParameter("RequestBODfile");
		
		
		if(id==null || id.trim().length()==0 || pwd==null || pwd.trim().length()==0)
		{
			String message = ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.errormessage.logonInfo");
			request.setAttribute("ErrorMessage",message);
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, message, null));
			return null;
		}
		String requestBOD = null;
		if(requestFileContent!=null && requestFileContent.trim().length()>0)
		{
			requestBOD = requestFileContent;
		}
		else if(localFilePath==null || !((new File(localFilePath)).exists()))
		{
			String message = ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.errormessage.requestBODFilePath");
			request.setAttribute("ErrorMessage",message);
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, message, null));
			return null;
		}
		else
		{
			requestBOD = getFileContent(localFilePath);
			if(requestBOD==null)
			{
				String message = ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.errormessage.readrequestFileContent");
				request.setAttribute("ErrorMessage",message);
				ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, "my message for new log", null));
				return null;
			}
		}
		
		Object responseBOD = null;
		
		try
		{
				responseBOD = handler.processLogonRequest(id,pwd,requestBOD,langId);
		}
		catch(TelesalesServicesException tse)
		{
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, tse.toString(), tse));
			//CorePlugin.logException(tse);
			request.setAttribute("ErrorMessage",tse.toString());
		}
		if(!request.getMethod().equalsIgnoreCase("POST"))
		{
		
			if(responseBOD!=null)
			{
				createResponseFile((String)responseBOD,directoryPath,resFileName,request,id);
			}
			else
			{
				String message = ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.errormessage.logonRequestFailed");
				request.setAttribute("ErrorMessage",message);
				ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, message, null));
			}
		}
		return responseBOD;
	}
	
	/**
	 * This method is used to process other service type requests.
	 * This constructs service context for other service type and call communication layer to process the request. 
	 * @param request
	 * @param response
	 * @return response BOD if successfully done else return null
	 */
	private Object processRequest(HttpServletRequest request, HttpServletResponse response){
		
		String memberId = request.getParameter("memberId");
		String runAsID = request.getParameter("runAsId");
		String storeId = request.getParameter("storeId");
		String localFilePath = request.getParameter("requestFilePath");
		String resFileName = request.getParameter("resFileName");
		String userId = request.getParameter("logonId");
		String pwd = request.getParameter("password");
		String langId = request.getParameter("langId");
		String directoryPath = request.getParameter("respDirPath");
		String requestFileContent = request.getParameter("RequestBODfile");
		
		if(userId==null || userId.trim().length()==0 || pwd==null || pwd.trim().length()==0)
		{
			String message = ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.errormessage.loggingInfo");
			request.setAttribute("ErrorMessage",message);
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, message, null));
			return null;
		}
		if(memberId==null || memberId.trim().length()==0 || runAsID==null || runAsID.trim().length()==0
				|| storeId==null || storeId.trim().length()==0)
		{
			String message = ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.errormessage.otherInfo");
			request.setAttribute("ErrorMessage",message);
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, message, null));
			return null;
		}
		String requestBOD = null;
		if(requestFileContent!=null && requestFileContent.trim().length()>0)
		{
			requestBOD = requestFileContent;
		}
		else if(localFilePath==null || !((new File(localFilePath)).exists()))
		{
			String message = ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.errormessage.requestBODFilePath");
			request.setAttribute("ErrorMessage",message);
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, message, null));
			return null;
		}
		else
		{
			requestBOD = getFileContent(localFilePath);
			if(requestBOD==null)
			{
				String message = ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.errormessage.readrequestFileContent");
				request.setAttribute("ErrorMessage",message);
				ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, message, null));
				return null;
			}
		}
		
		Object responseBOD = null;
		try
		{
			responseBOD = handler.getResponse(userId,pwd,memberId,runAsID,storeId,requestBOD,langId);
		}
		catch(TelesalesServicesException tse)
		{
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, tse.toString(), null));
			//CorePlugin.logException(tse);
			request.setAttribute("ErrorMessage",tse.toString());
		}
		if(!request.getMethod().equalsIgnoreCase("POST"))
		{
		    if(responseBOD!=null) 
			{
				createResponseFile((String)responseBOD,directoryPath,resFileName,request,userId);
			}
			else
			{
				String message = ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.errormessage.otherRequestFailed");
				request.setAttribute("ErrorMessage",message);
				ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, message, null));
			}
		}
		return responseBOD;
	}
	
  /**
	* This method is used to forward request.
	* @param string
	* @throws IOException
	* @throws ServletException
	*/
	private void gotoPage(HttpServletRequest request, HttpServletResponse
	response,
	String pageName) throws ServletException, IOException {
			String page = "/request.jsp";
			if ("request".equals(pageName)) 
			{
				page = "/request.jsp";
            }
			else if ("results".equals(pageName)) 
			{
				page = "/results.jsp";
			}
			else if ("logonResults".equals(pageName)) 
			{
				page = "/logonResults.jsp";
			}
			else if ("logoffResults".equals(pageName)) 
			{
				page = "/logoffResults.jsp";
			}
			else if ("LogoffRequest".equals(pageName)) 
			{
				page = "/LogoffRequest.jsp";
			}
			else if ("LogonRequest".equals(pageName)) 
			{
				page = "/LogonRequest.jsp";
			}

			request.getRequestDispatcher(page).forward(request, response);
	}

	/**
	 * This method is used to process logoff request. 
	 * This constructs service context for stop service type and call communication layer to process the request.
	 * @param request
	 * @param response
	 * @return true if request is successfully done else returns false.
	 * @throws ServletException
	 * @throws IOException
	 */
	private boolean  processLogoffrequest(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		String memberId = request.getParameter("memberId");
		String userId = request.getParameter("logonId");
		String pwd = request.getParameter("password");
		String langId = request.getParameter("langId");
	//	String localFilePath = request.getParameter("requestFilePath");
		
		if(userId==null || userId.trim().length()==0 || pwd==null || pwd.trim().length()==0)
		{
			String message = ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.errormessage.loggingInfo");
			request.setAttribute("ErrorMessage",message);
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, message, null));
			return false;
		}
		if(memberId==null || memberId.trim().length()==0)
		{
			String message = ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.errormessage.memberInfo");
			request.setAttribute("ErrorMessage",message);
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, message, null));
			return false;
		}
		
		try
		{
			handler.processLogoffRequest(userId,pwd,memberId,langId);
		}
		catch(TelesalesServicesException tse)
		{
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, tse.toString(), null));
			//CorePlugin.logException(tse);
			request.setAttribute("ErrorMessage",tse.toString());
			return false;
		}
		
		return true;
	}
	
	/**
	 * This method is used to read request BOd file content.
	 * @param filepath
	 * @return filecontent
	 */
	private String getFileContent(String filepath)
	{
		
		String startupTime = new Date().toString();
    	String logText = ATPTTracingPlugin.getFormattedMessage("salesCenterWebTestTool.LogInfo.FileReadingstartup", new String[] { startupTime,filepath }); //$NON-NLS-1$
    	ATPTTracingPlugin.log(new Status(IStatus.INFO, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.OK, logText, null));
		
			String filestring = null;
			File ffile = new File(filepath);
			long value  = ffile.length();
			byte[] infile = new byte[(new Integer(Long.toString(value))).intValue()];
			FileInputStream fis = null; 
			BufferedInputStream bis = null;
			DataInputStream dis = null;
			try 
			{
				fis = new FileInputStream(ffile); 
				bis = new BufferedInputStream(fis);
				dis = new DataInputStream(bis);
				try 
				{
					
					int filelength = dis.read(infile);
					filestring = new String(infile, 0, filelength);
					
				} 
				catch(IOException iox) 
				{
					filestring = null;
					ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, iox.toString(), null));
				}
			}
			catch (FileNotFoundException fnf) 
			{
				filestring =null;
				ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, fnf.toString(), null));
				
			}
			finally
			{
				try
				{
					
					dis.close();
					bis.close();
					fis.close();
				}
				catch(IOException ioe)
				{
					ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, ioe.toString(), null));
				}
			}
			
			String endTime = new Date().toString();
	    	String endlogText = ATPTTracingPlugin.getFormattedMessage("salesCenterWebTestTool.LogInfo.FileReadingfinish", new String[] { endTime ,filepath}); //$NON-NLS-1$
	    	ATPTTracingPlugin.log(new Status(IStatus.INFO, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.OK, endlogText, null));

			
		return filestring;
	}
	
	/**
	 * This method is used to write response BOD into filesystem.
	 * @param fileContent response BOD content
	 * @param directoryPath directory path to store the response
	 * @param outputfilename
	 * @param request
	 * @param logonId
	 */
	private void createResponseFile(String fileContent,String directoryPath,String outputfilename,HttpServletRequest request,
			 							String logonId)
	{
		
		
		OutputStream fout= null;
	    OutputStream bout= null;
	    OutputStreamWriter out = null;
	    String fileName=null;
		try
		{
			
			if(directoryPath==null || directoryPath.trim().length()==0)
			{
				directoryPath = "c:\\temp\\response";
			}
			directoryPath = directoryPath + "\\" + logonId;
			if(outputfilename==null || outputfilename.trim().length()==0)
			{
				outputfilename = "responseBOD";
			}
			
			File file = new File(directoryPath);
			if(!file.exists())
			{
				file.mkdirs();
			}
			fileName = directoryPath+"\\"+outputfilename+".xml";
			
			String startTime = new Date().toString();
	    	String startlogText = ATPTTracingPlugin.getFormattedMessage("salesCenterWebTestTool.LogInfo.FileWritingStart", new String[] { startTime,fileName }); //$NON-NLS-1$
	    	ATPTTracingPlugin.log(new Status(IStatus.INFO, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.OK, startlogText, null));
	
			
			file = new File(fileName);
	        fout = new FileOutputStream(file);
	        int initialBufferSize = 1000000;
	        bout = new BufferedOutputStream(fout,initialBufferSize);
	        out = new OutputStreamWriter(bout, "UTF8");
	        out.write(fileContent);
		    request.setAttribute("ResponseFile",fileName);
		    if(ATPTTracingPlugin.DEBUG_LOGGING)
		    {
		    	ATPTTracingPlugin.log(new Status(IStatus.OK, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.OK, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.meesage.responsefilename")+fileName, null));
		    }
		    
	    }
		catch (Exception e)
		{	//Catch exception if any
			ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, e.toString(), null));
		}
		finally
		{
			try
			{
				out.flush();
				out.close();
				bout.close();
				fout.close();
				
			}
			catch(IOException ioe)
			{
				ATPTTracingPlugin.log(new Status(IStatus.ERROR, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.ERROR, ioe.toString(), null));
			}
		}

		String endTime = new Date().toString();
    	String endlogText = ATPTTracingPlugin.getFormattedMessage("salesCenterWebTestTool.LogInfo.FileWritingfinish", new String[] { endTime, fileName }); //$NON-NLS-1$
    	ATPTTracingPlugin.log(new Status(IStatus.INFO, ATPTTracingPlugin.getResourceString("salesCenterWebTestTool.UniqueIdentifier"), IStatus.OK, endlogText, null));


	}
}
